/* DelinquencyToExcel.rex */
/*
Les Koehler
9Jan2006
Reads in the Delinquency .prt file and places data in Excel
*/
Arg monyy '('print
Call Time('r')                     /* Just to see how long this takes */
print?=Abbrev(print,'PR')
/* Define location of the .prt file  WILL HAVE TO BE CHANGED DEPENDENT ON SYSTEM ITS RUNNING ON */
file_path = 'c:\Documents and Settings\Les\My Documents\HOA\Financials\'
Trace or
parse value hoadate(monyy) with err? mon yy rest
if err? then do
  say mon yy rest
  exit

end
months='JanFebMarAprMayJunJulAugSepOctNovDecJan'
file_name=mon||yy'_Delinquency.prt'

/*file_name = 'G5544907.prt' */
--file_name = 'Nov06_Delinquency.prt'
infile = file_path||file_name
Parse Var file_name fname'.'.
outfile = file_path||fname'.xls'
Call syscls
Call killexcel
Signal On SYNTAX

xlobj = .oleObject~new('Excel.Application') /* Create an Excel object */
xlobj~Visible = .true                           /* Make Excel visible */
xlobj~Application~SheetsInNewWorkBook = 1   /*Create a new workbook with 1 worksheet */
xlobj~WorkBooks~Add
font_name = 'Arial Rounded MT Bold' /* Define the font attributes we'll use later */
font_size = 9      /* Leave the font_size BIG - the printing to a single page will */
                    /* take care of it fitting on the sheet */

/* Need this to convert column numbers to column letters */
col_letters = 'A B C D E F G H I J K L M N O P Q R S T U V W X Y Z'

/* Retrieve some constant values we'll need later (they're stored within Excel) */
xllastcell    = xlobj~GetConstant('xlLastCell')
xlright       = xlobj~GetConstant('xlRight')
xledgeleft    = xlobj~GetConstant('xlEdgeLeft')
xledgetop     = xlobj~GetConstant('xlEdgeTop')
xledgebottom  = xlobj~GetConstant('xlEdgeBottom')
xledgeright   = xlobj~GetConstant('xlEdgeRight')
xlcontinuous  = xlobj~GetConstant('xlContinuous')
xlcenter      = xlobj~GetConstant('xlCenter')
xllandscape   = xlobj~GetConstant('xlLandScape')
xlpaperletter = xlobj~GetConstant('xlPaperLetter')

Parse Var fname curmonth +3 curyear +2 report
hit=Lastpos(curmonth,months)
prevmonth=Substr(months,hit-3,3)
If prevmonth='Dec' Then prevyear=Right(curyear-1,2,0)
Else prevyear=curyear
known?.=0                                              /* Known names */
prev_file=prevmonth||prevyear||report'.xls'
oldfile="'"file_path||"["prev_file"]Sheet1'!"
txtstream = .stream~new(file_path||prev_file)
exists?=txtStream~query('exists')\= ''
If exists? Then Call get_cell_names file_path||prev_file

/* Fastest method in ooRexx to read in an entire file and convert it to an array */
istream = .stream~new(infile)
iarray  = istream~charin(,istream~chars)~makearray
istream~close

/* Define some boolean values (you'll see their use as the code progresses) */
found_title = .false
skip_line = .false
last=.false
Trace or

/* Define an array to store our header lines - need to do all formatting before insert of headers */
header_lines = .array~new
row = 6                             /* Starting point for report data */
f.0=7                                   /* Number of fields in report */
Do i = 1 To iarray~items    /* Process each array element (rows in our text file) */
  aline = iarray[i]
  If Space(aline)=' ' Then Iterate i
  If Left(aline~word(1),1) = '-' Then Iterate i   /* Don't need these line */

  If aline~word(aline~words) = 'TOTAL' Then found_title = .true
  If \found_title Then header_lines[header_lines~items + 1] = aline         /* These must be header lines */
  Else Do
    row = row + 1
 /*if row=33 then trace r */
    Parse Var aline . 19 f.1 35 f.2 70 f.3 83 f.4 95 f.5 ,
     107 f.6 120 f.7 132 .
    If Space(f.2)\='TOTAL:' Then column=1            /* Ordinary data */
    Else Do
      column = 2
      last=.true
    End
    Do w = column To f.0
      temp = Space(f.w)
      xlobj~Cells(row,w)~Value=temp
      column = column + 1
    End
    If Space(f.7)='TOTAL' Then Do                    /* Column header */
      If exists? Then Do
        column=f.0+1
        xlobj~Cells(row,column)~Value='Delta'
      End
    End
    Else Do                                               /* Row data */
      name='_'Translate(Space(f.1 f.2),'_______',':()/& -')
      If exists? & known?.name Then Do             /* Calc Net Change */
        xlobj~Cells(row,column)~formula='=RC[-1]-'oldfile||name
      End
      column = column - 1
      xlobj~Cells(row,column)~name = name
    End
    If skip_line Then Do
      row = row + 1
      skip_line = .false
    End
  End                                                  /* else clause */
  If last Then Leave i
End                                               /* 1 to array~items */

lastcell = xlobj~ActiveCell~SpecialCells(xllastcell)~Address    /* Determine last cell used */
Parse Var lastcell '$'max_column'$'max_row                      /* Parse that for column & row */

/* Set the font name and size for the used range */
xlobj~Range('A5:'lastcell)~Select
myselection = xlobj~Selection
mySelection~Font~Name = font_name
mySelection~Font~Size = font_size

/* Autofit the column widths to match our data */
xlobj~Columns('A:'max_column)~select
xlobj~Selection~Columns~AutoFit

/* Right justify all data */
xlobj~Range('C8:'lastcell)~Select
myselection = xlobj~Selection
mySelection~HorizontalAlignment = xlright
mySelection~NumberFormat = '#0.00'

/* Draw boxes around only the cells that are not .nil */
max_column_number = col_letters~wordpos(max_column)
Do r = 5 To max_row
  Do c = 1 To max_column_number
    column_letter = col_letters~word(c)
    xlobj~Range(column_letter||r)~Select
    myselection = xlobj~Selection
    box?=1
    If c=1 Then Do
      next_column_letter=col_letters~word(2)
      xlobj~Range(next_column_letter||r)~Select
      myselection_next = xlobj~Selection
      If mySelection_next~Value = .nil Then box?=0
    End
    If mySelection~Value \= .nil & box? Then Do
      mySelection~Borders(xledgeleft)~LineStyle   = xlcontinuous
      mySelection~Borders(xledgetop)~LineStyle    = xlcontinuous
      mySelection~Borders(xledgebottom)~LineStyle = xlcontinuous
      mySelection~Borders(xledgeright)~LineStyle  = xlcontinuous
    End
  End
End

/* Now that we are done formatting, go back and insert our header line data */
Do i = 1 To header_lines~items
  line                            = header_lines[i]
  if subword(line,1,2)='RUN DATE:' then line=delword(line,1,3)
    else if subword(line,1,2)='RUN TIME:' then line=delword(line,1,4)
  if line='' then iterate i
 
  if word(line,words(line)-1)='PAGE' then ,
   line=delword(line,words(line)-1)

  xlobj~Cells(i,1)~Value          = space(line)
  xlobj~Cells(i,1)~Font~Name      = font_name /* Set the font name and size for the header line */
  xlobj~Cells(i,1)~Font~Size      = font_size
  xlobj~Range('A'i':'max_column||i)~Select
  myselection                     = xlobj~Selection
  mySelection~HorizontalAlignment = xlcenter  /* Center and merge the header line */
  mySelection~Merge
End

xlobj~DisplayAlerts = .false        /* Don't alert us if the document already exists */
xlobj~ActiveSheet~SaveAs(outfile)                /* Save the document */

/* Set up information to print */
xlobj~ActiveSheet~PageSetup~PrintArea         = '$A$1:'lastcell
xlobj~ActiveSheet~PageSetup~LeftMargin        = xlobj~InchesToPoints(.9)
xlobj~ActiveSheet~PageSetup~RightMargin       = xlobj~InchesToPoints(.5)
xlobj~ActiveSheet~PageSetup~TopMargin         = xlobj~InchesToPoints(.5)
xlobj~ActiveSheet~PageSetup~BottomMargin      = xlobj~InchesToPoints(.5)
xlobj~ActiveSheet~PageSetup~HeaderMargin      = xlobj~InchesToPoints(0)
xlobj~ActiveSheet~PageSetup~FooterMargin      = xlobj~InchesToPoints(0)
/*
xlobj~ActiveSheet~PageSetup~Orientation       = xlLandscape
xlobj~ActiveSheet~PageSetup~Orientation       = xlPortrait
*/
xlobj~ActiveSheet~PageSetup~PaperSize         = xlpaperletter
xlobj~ActiveSheet~PageSetup~Zoom              = .false
xlobj~ActiveSheet~PageSetup~FitToPagesWide    = 1
xlobj~ActiveSheet~PageSetup~FitToPagesTall    = 1
if print? then do
  xlobj~ActiveWindow~SelectedSheets~PrintOut  /* Comment out this line to NOT print */
end
xlobj~Range('A1')~Select                    /* Be nice and place the cursor at the top of the document */
xlobj~WorkBooks(1)~Close(saveall)               /* Close the document */
xlobj~Quit                                              /* Quit Excel */
Say 'Your Completed Excel Document Was Saved As:' outfile
Say 'Elasped Time To Convert To Excel Was:' Time('e') 'Seconds'
Exit
GET_CELL_NAMES:
Procedure Expose known?.
Parse Arg file
/* Create the Excel object */
xlobj = .OleObject~New('Excel.Application')

/*
    Turn the visible attribute off - there's nothing to see in this demostration
*/
xlobj~Visible = .false

/*Open the existing workbook */
infile = file
xlobj~WorkBooks~Open(file)

/*We need to determine our lastcell (we'll need the constant to do that) */
xllastcell = xlobj~GetConstant('xlLastCell')
lastcell = xlobj~ActiveCell~SpecialCells(xllastcell)~Address
Parse Var lastcell '$'max_column'$'max_row

Do r=5 To max_row
  Parse Value examine_cell(r) With flag name
  If flag='VALUE' Then Do
    name='_'Translate(Space(name),'_______',':()/& -')
    known?.name=1
  End
End

/*Quit Excel */
xlobj~Quit
Return

EXAMINE_CELL: Procedure Expose xlobj max_row
Arg row
cell_value = xlobj~Cells(row,'A')~Value
cell_formula = xlobj~Cells(row,'A')~Formula
Select
  When cell_formula = '' Then Do
    c = 'EMPTY'
    cv = ''
  End
  When cell_value \= cell_formula Then Do
    c = 'FORMULA'
    cv = cell_formula
  End
  Otherwise Do
    c = 'VALUE'
    cv = cell_value
  End
End
If c\='VALUE'& row<max_row Then Return 'EMPTY'
If cv='UNIT #' Then Return 'EMPTY'

cell_value = xlobj~Cells(row,'B')~Value
cell_formula = xlobj~Cells(row,'B')~Formula
Select
  When cell_formula = '' Then Do
    c = 'EMPTY'
    cv = ''
  End
  When cell_value \= cell_formula Then Do
    c = 'FORMULA'
    cv = cell_formula
  End
  Otherwise Do
    c = 'VALUE'
    cv = cv cell_value
  End
End
/*
    say 'Cell' col||row"'s Contents Are "cv c
*/
Return c cv

SYNTAX:
Say 'SYNTAX Error On Line' sigl 'ERRORTEXT'(rc)
/* If we have an error, we want to be sure to quit Excel, don't it will be an orphaned process */
xlobj~Quit
Exit
::requires "KillExcel.rex"
::requires "titles.rex"
::requires "hoadate.rex"
